@ECHO OFF
if "%CommonProgramFiles(x86)%"=="" (goto X32) else (goto X64)
:X32
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\BestTech\GCC Developer Lite\GCC\ARM\bin"`) DO SET PATH=%%t
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\BestTech\openocd"`) DO SET PATH=%%t;%PATH%
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles%\BestTech\GCC Developer Lite\TARGET"`) DO SET TARGET_FOLDER=%%t
GOTO INPUT
:X64
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\BestTech\GCC Developer Lite\GCC\ARM\bin"`) DO SET PATH=%%t
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\BestTech\openocd"`) DO SET PATH=%%t;%PATH%
FOR /F "usebackq" %%t IN (`83 "%ProgramFiles(x86)%\BestTech\GCC Developer Lite\TARGET"`) DO SET TARGET_FOLDER=%%t
GOTO INPUT
:INPUT
@rmdir /S /Q out
@mkdir out
@set BL_SELECT_TARGET_NAME=%1
for /f "tokens=* delims=" %%L in (SAM7TARGETLIST.txt) do call :sub %%L %%M
@pause
goto exit
:sub
@set BL_SELECT_SERIES=NON
@set BL_BOOT_FILE=boot_thumb.o
@set BL_UDP=
@set BL_CLOCK=48000000
@set BL_BIN=
@set BL_SELECT_TARGET_NAME=%1
@set BL_PORT=%2
if %BL_SELECT_TARGET_NAME% == S512 (set BL_SELECT_SERIES=SAM7S)
if %BL_SELECT_TARGET_NAME% == S256 (set BL_SELECT_SERIES=SAM7S)
if %BL_SELECT_TARGET_NAME% == S128 (set BL_SELECT_SERIES=SAM7S)
if %BL_SELECT_TARGET_NAME% == S64 (set BL_SELECT_SERIES=SAM7S)
if %BL_SELECT_TARGET_NAME% == S32 (set BL_SELECT_SERIES=SAM7S)
if %BL_SELECT_TARGET_NAME% == X512 (set BL_SELECT_SERIES=SAM7X)
if %BL_SELECT_TARGET_NAME% == X256 (set BL_SELECT_SERIES=SAM7X)
if %BL_SELECT_TARGET_NAME% == X128 (set BL_SELECT_SERIES=SAM7X)
if %BL_SELECT_SERIES% == NON (GOTO FAIL)
if %BL_PORT% == USB (set BL_UDP=cdc_enumerate.c)
if %BL_SELECT_TARGET_NAME% == S32 (set BL_CLOCK=48000000)
if %BL_SELECT_TARGET_NAME% == S32 (if %BL_PORT% == USB (GOTO FAIL))
@set BL_BIN=AT91SAM7%BL_SELECT_TARGET_NAME%_%BL_PORT%_BOOTLOADER
@echo TARGET  : AT91SAM7%BL_SELECT_TARGET_NAME%
@echo PORT    : %BL_PORT%
@echo SERIES  : %BL_SELECT_SERIES%
@echo BOOTCODE: %BL_BOOT_FILE%
@echo FILENAME: %BL_BIN%
@echo RpC...
arm-none-eabi-gcc -I %TARGET_FOLDER%\%BL_SELECT_SERIES% -L %TARGET_FOLDER%\%BL_SELECT_SERIES% -mcpu=arm7tdmi -D__%BL_PORT%__ -D__AT91SAM7%BL_SELECT_TARGET_NAME%__ -DF_CPU=%BL_CLOCK% -mthumb-interwork -mthumb -nostartfiles -std=gnu99 -Wall -Wno-main -Wnested-externs -Wshadow -Wcast-align -Wimplicit -Wpointer-arith -Wswitch -Wredundant-decls -Wreturn-type -Wshadow -Wunused -Os -T%TARGET_FOLDER%\%BL_SELECT_SERIES%\sam7%BL_SELECT_TARGET_NAME%_rom.x -Xlinker -Map -Xlinker ./out/%BL_BIN%.map %TARGET_FOLDER%\%BL_SELECT_SERIES%\%BL_BOOT_FILE% %BL_UDP% termsam7.c -lm -l%BL_SELECT_SERIES%_thumb -pipe -o ./out/%BL_BIN%.elf
@IF ERRORLEVEL 1 GOTO FAIL
@echo TCYmF...
arm-none-eabi-size ./out/%BL_BIN%.elf
arm-none-eabi-objcopy -O binary  ./out/%BL_BIN%.elf ./out/%BL_BIN%.bin
copy /Y .\out\%BL_BIN%.elf .\out\termsam7.elf
:FAIL
:exit